#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Transforme les adresses DNS en adresses IP

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

my $sql = $mysql->prepare("SELECT host_address addr FROM host WHERE host_address NOT REGEXP '^[0-9.]+\$'");
$sql->execute;

while(my $h = $sql->fetchrow_hashref) {
	my $addr = $h->{'addr'};
	my $ip = `host $addr | awk '\$NL ~ /address/ { print \$NF }'`;
	chomp $ip;

	if($ip =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) {
		$mysql->do("UPDATE host SET host_address='$ip' WHERE host_address='$addr'");
		print "INFO: $addr change en $ip\n";
	} else {
		print STDERR "ERREUR: $addr\n";
	}
}

$sql->finish;
$mysql->disconnect;
