#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Suppression de toutes les commandes non utilises

use strict;
use warnings;
use DBI;

# COMMANDES NRPE
# select command_command_id_arg from service where command_command_id = (select command_id from command where command_name='check_nrpe_arg')

# COMMANDES NON UTILISEES
# select command_name from command where command_id NOT IN (select command_command_id from service);

# SERVICES NON UTILISES
# select service_description from service where service_id not in (select service_service_id from host_service_relation) and service_register='1';

# SERVICES TPL NON UTILISES
# select service_description from service where service_id not in (select service_template_model_stm_id from service) and service_register='0';

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

my $sql = $mysql->prepare("SELECT command_name
			FROM command LEFT JOIN
				(SELECT s.command_command_id s_id, h.command_command_id h_id
				FROM service s, host h) sh
			ON command_id IN (sh.s_id, sh.h_id)
			WHERE s_id IS NULL AND h_id IS NULL AND command_type=2");
$sql->execute;

while(my $r = $sql->fetchrow_hashref) {
	my $command = $r->{'cn'};
	my $nb = $mysql->do("DELETE FROM command WHERE command_name='$command';") unless $command =~ /salles/;
	print "$nb commandes supprimees\n";
}

$sql->finish;
$mysql->disconnect;
