#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Supprime les templates de services inutilises

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

my $sql = $mysql->prepare("SELECT service_id id FROM service WHERE service_id NOT IN (SELECT service_template_model_stm_id FROM service) AND service_register='0';");
$sql->execute;

while(my $s = $sql->fetchrow_hashref) {
	my $id = $s->{'id'};
	$mysql->do("DELETE FROM service WHERE service_id=$id");
}

$sql->finish;
$mysql->disconnect;
